<?php
/**
 * 自动采集入库
 * 自动采集入库原理：通过定时重复访问本文件(index.php)实现自动采集与入库功能
 * 访问URL：http://YOURDOMAIN/hack.php?hackname=collect
 * 访问模式：GET
 * 参数列表：
 * rid				采集项目ID,多个项目ID用/分开
 * adminuid			用户ID
 * adminname		用户名
 * interval			采集时间间隔(可选，单位秒，设置为0或为空则忽略间隔时间直接采集)
 * unimport			设置不入库标记(可选，当影片名称包含相同字符则只采集不入库，如是中文，必须使用urlencode函数编码)
 *
 * 举例：
 * 访问：http://YOURDOMAIN/hack.php?hackname=collect&rid=1&adminuid=1&adminname=admin&interval=3600
 * 如果距上次采集的间隔时间大于3600秒（1小时），则会自动采集项目ID为1的项目并完成入库，入库影片的发布人ID为1,用户名为admin
 *
 * 访问采集链接返回内容：
 * Ignore!!			距上次采集的时间小于间隔时间，忽略本次采集
 * Param Error!!	参数设置错误
 * Done!!280s		采集入库完成，共耗时280秒
 */

!defined('IN_PHPVOD') && exit('Forbidden');
$nowtime = time();
$recordfile = PHPVOD_HACK_ROOT . 'recordfile.php';

initvar('interval', 'GP', 0);
if(is_numeric($interval) && $interval>0)
{
	if(is_file($recordfile))
	{
		$lasttime = include $recordfile;
	}
	else
	{
		$lasttime = 0;
	}

	if($lasttime + $interval > $nowtime)
	{
		exit('Ignore!!'); //小于间隔时间，忽略本次采集
	}
}

writeover($recordfile, "<?php\r\nreturn $nowtime;\r\n?>");

set_time_limit(0); //脚本运行不超时
ignore_user_abort(true); //忽略用户中断

include PHPVOD_ROOT . 'data/cache/class.php';
include PHPVOD_ROOT . 'data/cache/nation.php';
require_once PHPVOD_HACK_ROOT . 'function.php';

initvar(array('rid','unimport','adminname','adminuid'), 'GP', 0);
(empty($rid) || empty($adminname) || empty($adminuid)) && exit('Param Error!!');
$admin['uid'] = $adminuid;
$admin['username'] = $adminname;
$unimport = str_convert(urldecode($unimport), $db_charset, 'utf-8');
$rid_array = explode('/', $rid);
$total_time = 0; //采集累计时长

foreach($rid_array as $rid)
{
	//日志变量
	$report = array('import_success'=>0, 'import_fail'=>0, 'import_unsubmit'=>0, 'import_dataerror'=>0);

	//开始时间
	$starttime = time();

	//生成缓存
	createCollectCache($rid, array('rule','replace','listpage'));

	//收集影片地址链接
	$curlcfg = PHPVOD_HACK_ROOT . 'curl' . DIRECTORY_SEPARATOR . 'curlcfg.php'; //curl配置文件
	if(is_file($curlcfg))
	{
		include_once $curlcfg;
		if(isset($curlcfg[$rid]) && is_file(PHPVOD_HACK_ROOT . 'curl' . DIRECTORY_SEPARATOR . $curlcfg[$rid]))
		{
			include_once PHPVOD_HACK_ROOT . 'curl' . DIRECTORY_SEPARATOR . $curlcfg[$rid];
		}
	}

	include PHPVOD_HACK_ROOT . 'cache/r' . $rid . '_ruledb.php'; //规则缓存
	include PHPVOD_HACK_ROOT . 'cache/r' . $rid . '_replacedb.php'; //替换缓存
	include PHPVOD_HACK_ROOT . 'cache/r' . $rid . '_listurlsdb.php'; //列表缓存

	foreach($listUrls as $listUrl)
	{
		$links = getListLink($listUrl, $listLinkArea, $listLink);

		if(is_array($links))
		{
			foreach($links as $j => $link)
			{
				$fields = $values = '';
				if(is_array($link)) //除链接外还有另外的字段
				{
					$linkurl = $link['fromurl'] = fixPath($link['fromurl'], $listUrl);
					foreach($link as $k => $v)
					{
						$v = str_replace(array("\\", "'"), array("\\\\", "\'"), $v);
						$fields .= empty($fields) ? $k : ','.$k;
						$values .= empty($values) ? "'$v'" : ",'$v'";
					}
				}
				else //只有链接
				{
					$linkurl = fixPath($link, $listUrl);
					$fields = 'fromurl';
					$values = "'$linkurl'";
				}

				$t = $db->get_one("SELECT id, serialise_flag, serialise_update_flag FROM pv_collectvideo WHERE rid='$rid' AND fromurl='$linkurl'");
				if(!$t) //新记录
				{
					$db->update("INSERT INTO pv_collectvideo(rid,{$fields}) VALUES('$rid',{$values})");
					//如果有采集图片
					if(isset($link['pic']) && $link['pic'] != '' && $videoPicDown == '1')
					{
						$lastid = $db->insert_id();
						$path_parts = pathinfo($link['pic']);
						$filename = $lastid . '.' . $path_parts['extension'];
						if(@copy($link['pic'], PHPVOD_HACK_ROOT . "pic/$filename"))
							$pic_flag = '1';
						else
							$pic_flag = '0';
						$db->update("UPDATE pv_collectvideo SET pic_flag='$pic_flag' WHERE id='$lastid'");
					}
				}
				else //影片地址已存在于pv_video表中
				{
					if($t['serialise_flag'] == '1') //连载
					{
						if(isset($link['serialise_update_flag']) && $link['serialise_update_flag'] == $t['serialise_update_flag'])
							continue; //如果连载更新标记相等则跳过
						if(isset($link['serialise_update_flag']))
							$db->update("UPDATE pv_collectvideo SET serialise_check='1',serialise_update_flag='$link[serialise_update_flag]' WHERE id='$t[id]'"); //将连载检测标记设为1
						else
							$db->update("UPDATE pv_collectvideo SET serialise_check='1' WHERE id='$t[id]'"); //将连载检测标记设为1
					}
				}
			}
		}
	}

	//采集影片
	$result = $db->query("SELECT * FROM pv_collectvideo WHERE rid='$rid' AND (collect_flag='0' OR serialise_check='1') ORDER BY serialise_check DESC");
	while($row = $db->fetch_array($result))
	{
		$video = getVideoInfo($row, $replacedb, $videoClassType, $videoClass, $videoNationType, $videoNation, $videoSubject, $videoPlayactor, $videoDirector, $videoYear, $videoMemo, $videoPic, $videoPicDown, $videoContent, $videoContentDelTag, $videoSerialiseFlag, $videoSerialiseSet, $videoUrlArea, $videoUrlType, $videoUrlReplaceType, $videoUrlNewpage, $videoUrlReplace, $videoUrl, $videoDelTag);
		array_cv($video);

		$urls = '';
		if(is_array($video['url']))
		{
			foreach($video['url'] as $url)
			{
				if($urls == '')
					$urls .= $url;
				else
					$urls .= "\r\n{$url}";
			}
		}

		//判断有没有采集成功
		if(empty($video['subject']) || empty($urls))
		{
			$report['import_dataerror']++;
			continue;
		}

		if($row['collect_flag'] == '0') //新记录
		{

			$db->update("UPDATE pv_collectvideo SET
					cid='$video[class]',
					nid='$video[nation]',
					subject='$video[subject]',
					pic='$video[pic]',
					pic_flag='$video[pic_flag]',
					playactor='$video[playactor]',
					director='$video[director]',
					year='$video[year]',
					memo='$video[memo]',
					content='$video[content]',
					url='$urls',
					collect_flag='1',
					serialise_flag='$video[serialise_flag]' WHERE id='$row[id]'
					");
		}
		elseif($row['serialise_flag'] == '1') //连载
		{
			if($urls != $row['url']) //如果采集到的地址与原有地址不同
			{
				$db->update("UPDATE pv_collectvideo SET
						subject='$video[subject]',
						pic='$video[pic]',
						pic_flag='$video[pic_flag]',
						playactor='$video[playactor]',
						director='$video[director]',
						year='$video[year]',
						memo='$video[memo]',
						content='$video[content]',
						url='$urls',
						collect_flag='1',
						serialise_flag='$video[serialise_flag]',
						serialise_check='0',
						serialise_update='1' WHERE id='$row[id]'
						");
			}
			else
			{
				$db->update("UPDATE pv_collectvideo SET serialise_check='0' WHERE id='$row[id]'");
			}
		}
	}

	//入库
	$result = $db->query("SELECT * FROM pv_collectvideo WHERE rid='$rid' AND collect_flag='1' AND submit_flag='0' AND (import_flag='0' OR serialise_update='1') ORDER BY id ASC");
	while($video = $db->fetch_array($result))
	{
		if(!empty($unimport) && strpos($video['subject'], $unimport) !== false)
		{
			$db->update("UPDATE pv_collectvideo SET submit_flag='1' WHERE id='$video[id]'");
			$report['import_unsubmit']++;
		}
		else
		{
			if(empty($video['subject']) || empty($video['pic']) || empty($video['content']) || empty($video['url']) || ($videoPicDown=='1' && $video['pic_flag']=='0'))
			{
				continue;
			}
			else
			{
				$return = import($video['id']); //入库影片
				$return === false ? $report['import_fail']++ : $report['import_success']++;
			}
		}
	}

	//添加日志文件
	$report['starttime'] = $starttime;
	$report['endtime'] = time();
	$reportstr = serialize($report);
	$db->update("INSERT INTO pv_collectlog(rid,collectdata) VALUES('$rid','$reportstr')");

	//累计时间
	$total_time = $total_time + ($report['endtime'] - $report['starttime']);
}

//更新站点影片总数
update_siteinfo(array('totalvideo'));
exit('Done!! ' . $total_time . 's');
?>