DROP TABLE IF EXISTS `pv_collectreplace`;
CREATE TABLE `pv_collectreplace` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `rid` int(10) unsigned NOT NULL default '0',
  `keyname` char(255) NOT NULL default '',
  `str1` char(255) NOT NULL default '',
  `str2` char(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `pv_collectrules`;
CREATE TABLE `pv_collectrules` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` char(255) NOT NULL default '',
  `encode` char(255) NOT NULL default '',
  `playerType` tinyint(2) NOT NULL default '0',
  `listType` tinyint(2) NOT NULL default '0',
  `listUrl` mediumtext NOT NULL,
  `listLinkArea` mediumtext NOT NULL,
  `listLink` mediumtext NOT NULL,
  `videoClassType` tinyint(2) NOT NULL default '3',
  `videoClass` mediumtext NOT NULL,
  `videoNationType` tinyint(2) NOT NULL default '5',
  `videoNation` mediumtext NOT NULL,
  `videoSubject` mediumtext NOT NULL,
  `videoPlayactor` mediumtext NOT NULL,
  `videoDirector` mediumtext NOT NULL,
  `videoYear` mediumtext NOT NULL,
  `videoMemo` mediumtext NOT NULL,
  `videoPic` mediumtext NOT NULL,
  `videoPicDown` tinyint(2) NOT NULL default '0',
  `videoContent` mediumtext NOT NULL,
  `videoContentDelTag` char(255) NOT NULL default '',
  `videoSerialiseFlag` mediumtext NOT NULL,
  `videoSerialiseSet` char(255) NOT NULL default '',
  `videoUrlArea` mediumtext NOT NULL,
  `videoUrlType` tinyint(2) NOT NULL default '7',
  `videoUrlReplaceType` tinyint(2) NOT NULL default '9',
  `videoUrlNewpage` mediumtext NOT NULL,
  `videoUrlReplace` mediumtext NOT NULL,
  `videoUrl` mediumtext NOT NULL,
  `videoDelTag` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `pv_collectvideo`;
CREATE TABLE `pv_collectvideo` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '规则ID',
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT '栏目ID',
  `nid` varchar(255) NOT NULL DEFAULT '' COMMENT '地区ID',
  `subject` varchar(255) NOT NULL DEFAULT '' COMMENT '标题',
  `pic` varchar(255) NOT NULL DEFAULT '' COMMENT '图片地址',
  `playactor` varchar(255) NOT NULL DEFAULT '' COMMENT '演员',
  `director` varchar(255) NOT NULL DEFAULT '' COMMENT '导演',
  `year` varchar(255) NOT NULL DEFAULT '' COMMENT '年代',
  `memo` text NOT NULL COMMENT '备注',
  `content` mediumtext NOT NULL COMMENT '内容简介',
  `url` mediumtext NOT NULL COMMENT '播放地址',
  `fromurl` varchar(255) NOT NULL DEFAULT '' COMMENT '采集地址',
  `pic_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '图片是否下载，0未下载；1已下载',
  `collect_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '影片是否已采集，0未采集；1已采集',
  `import_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已入库，0未入库；1已入库',
  `serialise_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否为连载影片，0已完结；1连载影片',
  `submit_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '影片是否设置有不入库标记，0允许入库；1不允许入库',
  `serialise_vid` varchar(255) NOT NULL DEFAULT '' COMMENT 'pv_video表中的vid,pv_urls表中的uid',
  `serialise_update` tinyint(1) NOT NULL DEFAULT '0' COMMENT '连载影片是否需要重新入库，0不需要（无更新），1需要（有更新）',
  `serialise_check` tinyint(1) NOT NULL DEFAULT '0' COMMENT '用于标记连载影片是否需要重新采集，0不需要；1需要',
  `serialise_update_flag` varchar(255) NOT NULL DEFAULT '' COMMENT '连载更新标记，可以通过比较此标记来判断连载影片是否有更新',
  PRIMARY KEY (`id`),
  KEY `fromurl` (`fromurl`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `pv_collectlog`;
CREATE TABLE `pv_collectlog` (
  `lid` int(10) unsigned NOT NULL auto_increment,
  `rid` int(10) unsigned NOT NULL default '0',
  `collectdata` char(255) NOT NULL default '',
  PRIMARY KEY (`lid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

INSERT INTO `pv_hackvar` VALUES ('collect_update_subject', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_pic', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_playactor', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_director', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_year', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_memo', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_update_content', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_samename', '1', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_cid', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_nid', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_director', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_playactor', '1', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_year', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_compare_memo', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_username', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_postdate_start', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_postdate_end', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_hits_min', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_hits_max', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_random_userinfo', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun', '0', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun_ids', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun_interval', '3600', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun_username', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun_userinfo', '', '');
INSERT INTO `pv_hackvar` VALUES ('collect_autorun_unimport', '', '');