<?php
!defined('IN_PHPVOD') && exit('Forbidden');
require_once PHPVOD_HACK_ROOT . "function.php";

initvar(array('act', 'rid'), 'GP', 0);

if(!$act || $act == 'import' || $act == 'unimport' || $act == 'unsubmit' || $act == 'serialise' || $act == 'search' || $act == 'unclass' || $act == 'unnation')
{
	$order = 'ORDER BY id DESC'; //排序方式
	switch($act)
	{
		//影片管理
		case '':
			$where = "rid='$rid' AND collect_flag='1'";
			$pageurl = "$basename&action=video&rid=$rid&";
			break;

		//已入库
		case 'import':
			$where = "rid='$rid' AND collect_flag='1' AND import_flag='1'";
			$pageurl = "$basename&action=video&act=import&rid=$rid&";
			break;

		//未入库
		case 'unimport':
			$where = "rid='$rid' AND collect_flag='1' AND submit_flag='0' AND (import_flag='0' OR serialise_update='1')";
			$order = 'ORDER BY serialise_update DESC, id DESC'; //需要更新的连载影片显示在最前面
			$pageurl = "$basename&action=video&act=unimport&rid=$rid&";
			break;

		//不入库
		case 'unsubmit':
			$where = "rid='$rid' AND collect_flag='1' AND submit_flag='1'";
			$pageurl = "$basename&action=video&act=unsubmit&rid=$rid&";
			break;

		//连载影片
		case 'serialise':
			$where = "rid='$rid' AND collect_flag='1' AND serialise_flag='1'";
			$order = 'ORDER BY serialise_update DESC, id DESC'; //需要更新的连载影片显示在最前面
			$pageurl = "$basename&action=video&act=serialise&rid=$rid&";
			break;

		//搜索影片
		case 'search':
			$basename = "$basename&action=video&rid=$rid";
			$where = "rid='$rid' AND collect_flag='1'";

			initvar(array('cid', 'nid', 'subject', 'subject_s'), 'GP', 0);
			if($cid != 'all')
			{
				if($_class[$cid]['cup'] == '0')
				{
					$subcid = '';
					foreach($_class as $svalue)
					{
						$fathers = explode(',', $svalue['fathers']);
						if(in_array($cid, $fathers))
						{
							if($subcid == '')
								$subcid .= "$svalue[cid]";
							else
								$subcid .= ",$svalue[cid]";
						}
					}
					$where .= $subcid != '' ? " AND cid IN($subcid)" : " AND cid IN(-1)";
				}
				else
				{
					$where .= " AND (cid='$cid')";
				}
			}

			if($nid != 'all')
			{
				$where .= " AND (nid='$nid')";
			}

			if(trim($subject) != '')
			{
				$subject = addslashes(str_replace('*', '%', $subject));
				$where .= $subject_s == 1 ? " AND subject LIKE '$subject'" : " AND (subject LIKE '%$subject%')";
			}

			$pageurl = "$basename&action=video&act=search&rid=$rid&cid=$cid&nid=$nid&subject=" . urlencode($subject) . "&";
			break;

		//未知栏目
		case 'unclass':
			$cids = '';
			foreach($_class as $value)
			{
				if($value['cup'] != '0')
				{
					if($cids == '')
						$cids .= $value['cid'];
					else
						$cids .= ",$value[cid]";
				}
			}

			$where = "rid='$rid' AND collect_flag='1' AND import_flag='0' AND cid NOT IN($cids)";
			$result = $db->query("SELECT cid FROM pv_collectvideo WHERE $where GROUP BY cid");
			while($row = $db->fetch_array($result))
			{
				$errcids[] = $row;
			}

			$pageurl = "$basename&action=video&act=unclass&rid=$rid&";
			break;

		//未知地区
		case 'unnation':
			$nids = '';
			foreach($_nation as $key => $value)
			{
				$nids = $nids == '' ? $key : $nids . ',' . $key;
			}

			$where = "rid='$rid' AND collect_flag='1' AND import_flag='0' AND nid NOT IN($nids)";
			$result = $db->query("SELECT nid FROM pv_collectvideo WHERE $where GROUP BY nid");
			while($row = $db->fetch_array($result))
			{
				$errnids[] = $row;
			}

			$pageurl = "$basename&action=video&act=unnation&rid=$rid&";
			break;
	}

	$rule = $db->get_one("SELECT videoPicDown FROM pv_collectrules WHERE id='$rid'");
	
	initvar('page', 'GP', 0);

	(!is_numeric($page) || $page < 1) && $page = 1;
	$limit = "LIMIT " . ($page - 1) * $db_adminperpage . ",$db_adminperpage";
	$rt = $db->get_one("SELECT COUNT(*) AS sum FROM pv_collectvideo WHERE $where");
	$pages = page_format(numofpage($rt['sum'], $page, $db_adminperpage, $pageurl));

	$videodb = array();
	$result = $db->query("SELECT * FROM pv_collectvideo WHERE $where $order $limit");
	while($row = $db->fetch_array($result))
	{
		$videocid = $row['cid'];
		$videonid = $row['nid'];

		if(is_numeric($videocid) && isset($_class[$videocid]) && $_class[$videocid]['cup'] != '0')
			$row['cid'] = '<span style="color: green;">' . $_class[$videocid]['caption'] . '</span>';
		else
			$row['cid'] = '<span style="color: red;">' . $videocid . '</span>';

		if(is_numeric($videonid) && isset($_nation[$videonid]))
			$row['nid'] = '<span style="color: green;">' . $_nation[$videonid] . '</span>';
		else
			$row['nid'] = '<span style="color: red;">' . $videonid . '</span>';

		$videodb[] = $row;
	}
	include_once get_hack_tpl('video');
}
//编辑影片
elseif($act == 'edit')
{
	initvar('step', 'GP', 2);
	if(!$step)
	{
		initvar('id', 'GP', 2);
		$row = $db->get_one("SELECT * FROM pv_collectvideo WHERE id='$id'");

		//海报
		//$path_parts = pathinfo($row['pic']);
		//$filename = $path_parts['basename'];
		//$extname = $path_parts['extension'];
		$path_parts = pathinfo($row['pic']);		
		$filename = $row['id'] . '.' . $path_parts['extension'];
		
		if(file_exists(PHPVOD_HACK_ROOT . "pic/$filename"))
			$vodimg = "$hackpath/pic/$filename";
		else
			$vodimg = $row['pic'];

		//连载
		ifcheck($row['serialise_flag'], 'serialise_flag');
		include_once get_hack_tpl('video');
	}
	elseif($step == '2')
	{
		initvar(array('rid', 'id', 'video'), 'GP', 0);

		$cid = $video['class'];
		if($_class[$cid]['cup'] == '0') adminmsg('video_class_error', 'goback', array(), 10);

		$db->update("UPDATE pv_collectvideo SET cid='$video[class]',nid='$video[nation]',subject='$video[subject]',playactor='$video[playactor]',director='$video[director]',year='$video[year]',memo='$video[memo]',content='$video[content]',url='$video[url]',serialise_flag='$video[serialise]' WHERE id='$id'");
		adminmsg('operate_success', "$basename&action=video&rid=$rid", array(), 10);
	}
}
//提交
elseif($act == 'post')
{
	initvar(array('operate', 'rid', 'ids'), 'GP', 0);
	if($operate == 'import') //导入影片
	{
		!$ids && adminmsg('operate_fail', 'goback', array(), 10);
		$n1 = $n2 = 0;
		if(is_array($ids))
		{
			foreach($ids as $id)
			{
				if(import($id) === false)
					$n2++; //导入失败
				else
					$n1++; //导入成功
			}
		}
		update_siteinfo(array('totalvideo')); //更新站点影片总数
		$j_url = $http_referer;
		adminmsg('video_import_success', $j_url, array($n1, $n2), 10);
	}
	elseif($operate == 'restart') //重新采集
	{
		$idstr = checkselid($ids);
		empty($idstr) && adminmsg('operate_fail', 'goback', array(), 10);
		//采集操作
		$renum = count($ids);
		$db->update("UPDATE pv_collectvideo SET collect_flag='0' WHERE id IN ($idstr)"); //设置未采集标记
		createCollectCache($rid, array('rule', 'replace')); //生成缓存
		writeover(PHPVOD_HACK_ROOT . 'cache/r' . $rid .'_data.php', "<?php\r\n\$total = " . $renum . ";\r\n?>"); //将需要采集的影片总数写入缓存
		$j_url = "$basename&action=collect&rid=$rid&act=getVideo&f=0&idstr=$idstr"; //跳转地址
		adminmsg('collect_video_content', $j_url, array(), 0);		
	}
	elseif($operate == 'serialise') //设置、取消连载
	{
		$idstr = checkselid($ids);
		empty($idstr) && adminmsg('operate_fail', 'goback', array(), 10);
		$db->update("UPDATE pv_collectvideo SET serialise_flag=ABS(serialise_flag-1) WHERE id IN($idstr)");
		$j_url = $http_referer;
		adminmsg('operate_success', $j_url, array(), 10);
	}
	elseif($operate == 'submit') //设置、取消不入库标记
	{
		$idstr = checkselid($ids);
		empty($idstr) && adminmsg('operate_fail', 'goback', array(), 10);
		$db->update("UPDATE pv_collectvideo SET submit_flag=ABS(submit_flag-1) WHERE id IN($idstr)");
		$j_url = $http_referer;
		adminmsg('operate_success', $j_url, array(), 10);
	}
	elseif($operate == 'del') //删除影片
	{
		!$ids && adminmsg('operate_fail', 'goback', array(), 10);
		foreach($ids as $id)
		{
			@extract($db->get_one("SELECT pic,pic_flag FROM pv_collectvideo WHERE id='$id'"));
			//$pic = basename($pic);
			$path_parts = pathinfo($pic);
			$pic = $id . '.' . $path_parts['extension'];			
			if($pic_flag == '1' && file_exists(PHPVOD_HACK_ROOT . "pic/$pic")) delfile(PHPVOD_HACK_ROOT . "pic/$pic");
			$db->query("DELETE FROM pv_collectvideo WHERE id='$id'");
		}
		$j_url = $http_referer;
		adminmsg('operate_success', $j_url, array(), 10);
	}

}
//全部入库
elseif($act == 'importall')
{
	initvar(array('rid', 'step'), 'GP', 0);

	if(isUn($rid)) adminmsg('video_import_isun', "$basename&action=video&rid=$rid", array(), 10);

	$num = 500; //入库步长
	$result = $db->query("SELECT * FROM pv_collectvideo WHERE rid='$rid' AND collect_flag='1' AND submit_flag='0' AND (import_flag='0' OR serialise_update='1') ORDER BY id ASC LIMIT $num");
	$recordNum = $db->num_rows($result);

	if($recordNum == 0) //没有记录符合入库条件（即全部入库）
	{
	    update_siteinfo(array('totalvideo')); //更新站点影片总数
	    adminmsg('operate_success');
	}

	$n = 0;
	while($video = $db->fetch_array($result))
	{
		$return = import($video['id']); //入库影片
		$return === false && $n++;
	}

	$start = $step * $num;
	$end = ($step + 1) * $num;
	$step++;

	adminmsg('video_import_running', "$basename&action=video&act=importall&rid=$rid&step=$step", array($start, $end, $n), 0);
}
//清空历史数据
elseif($act == 'delall')
{
	initvar('rid', 'GP', 0);
	$result = $db->query("SELECT id,pic FROM pv_collectvideo WHERE rid='$rid'");
	while($row = $db->fetch_array($result))
	{
		//$filename = basename($row['pic']);
		$path_parts = pathinfo($row['pic']);
		$filename = $row['id'] . '.' . $path_parts['extension'];		
		if(file_exists(PHPVOD_HACK_ROOT . "pic/$filename")) delfile(PHPVOD_HACK_ROOT . "pic/$filename");
	}
	$db->query("DELETE FROM pv_collectvideo WHERE rid='$rid'");
	$j_url = $http_referer;
	adminmsg('operate_success', $j_url, array(), 10);
}
//下载海报
elseif($act == 'downpic')
{
	initvar(array('flag', 'rid'), 'GP', 0);
	if(!$flag) //初始化缓存
	{
		createCollectCache($rid, array('downpicnum')); //生成缓存
		adminmsg('video_downpic_cache', "$basename&action=video&act=downpic&rid=$rid&flag=1&f=0", array(),0);
	}
	else
	{
		initvar('f','GP',0);
		include_once (PHPVOD_HACK_ROOT . 'cache/r' . $rid . '_data.php');
		if(isset($collect_step) && $collect_step > 0)
			$step = $collect_step;
		else
			$step = 1;

		$result = $db->query("SELECT * FROM pv_collectvideo WHERE rid='$rid' AND collect_flag='1' AND pic_flag='0' AND import_flag='0' ORDER BY id ASC LIMIT $step");

		$n = $db->num_rows($result);
		if($n > 0)
		{
			$subjects = ''; //存放影片名称列表
			while($row = $db->fetch_array($result))
			{
				$path_parts = pathinfo($row['pic']);
				$filename = $row['id'] . '.' . $path_parts['extension'];				

				if(pv_downfile($row['pic'], PHPVOD_HACK_ROOT . 'pic' . DIRECTORY_SEPARATOR . $filename) > 0)
					$db->update("UPDATE pv_collectvideo SET pic_flag='1' WHERE id='$row[id]'");
				else
					$db->update("UPDATE pv_collectvideo SET pic_flag='2' WHERE id='$row[id]'"); //下载图片失败时防止重复采集

				$subjects .= "<br />$row[subject]";
			}

			$num = $f + $n;
			$j_url1 = "$basename&action=video&act=downpic&rid=$rid&flag=1&f=$num";
			$j_url2 = "$basename&action=video&rid=$rid";
			adminmsg('video_downpic_running',$j_url1,array($num,$total,$subjects,$j_url1,$j_url2), 0);
		}

		adminmsg('video_downpic_success',"$basename&action=video&rid=$rid",array(),10);
	}
}
?>